"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.NextStrapiImageLoader = void 0;
const path = __importStar(require("path"));
class NextStrapiImageLoader {
    static completeConfiguration(strapiConfig = {}) {
        if (!strapiConfig.breakpoints) {
            strapiConfig.breakpoints = {
                large: 1000,
                medium: 750,
                small: 500,
            };
        }
        else {
            strapiConfig.breakpoints = strapiConfig.breakpoints;
        }
        if (!strapiConfig.excludeOrigins) {
            strapiConfig.excludeOrigins = [];
        }
        else {
            strapiConfig.excludeOrigins = strapiConfig.excludeOrigins;
        }
        if (!strapiConfig.publicUrl) {
            strapiConfig.publicUrl = "http://localhost:1337";
        }
        else {
            strapiConfig.publicUrl = strapiConfig.publicUrl;
        }
        if (!strapiConfig.excludeFiles) {
            strapiConfig.excludeFiles = [];
        }
        else {
            strapiConfig.excludeFiles = strapiConfig.excludeFiles;
        }
        return strapiConfig;
    }
    static with(nextConfig) {
        let loaderPath = path.join("node_modules", "next-strapi-image-loader", "dist", "loader.js");
        const strapiConfig = this.completeConfiguration(nextConfig["strapi"]);
        return Object.assign(Object.assign({}, nextConfig), { images: Object.assign(Object.assign({}, nextConfig["images"]), { loaderFile: loaderPath, loader: "custom", deviceSizes: Object.values(strapiConfig.breakpoints) }) });
    }
}
_a = NextStrapiImageLoader;
NextStrapiImageLoader.loader = ({ src, width }, mockConfig) => {
    let nextConfig;
    if (process.env.NODE_ENV === "test") {
        nextConfig = mockConfig;
    }
    else {
        nextConfig = require("next.config.js").strapi;
    }
    const config = _a.completeConfiguration(nextConfig["strapi"]);
    const breakPoint = Object.entries(config.breakpoints)
        .reverse()
        .find((breakPoint) => {
        const breakPointWidth = breakPoint[1];
        return breakPointWidth >= width;
    });
    const size = breakPoint ? breakPoint[0] + "_" : "";
    if (src.startsWith("http://") || src.startsWith("https://")) {
        const { origin, pathname } = new URL(src);
        if (!config.excludeOrigins.includes(origin)) {
            const { dir: rest, name: fileName, ext: extension, } = path.parse(pathname);
            return origin + rest + "/" + size + fileName + extension;
        }
        else {
            return src;
        }
    }
    else {
        if (!config.excludeFiles.includes(src)) {
            const { dir: rest, name: fileName, ext: extension } = path.parse(src);
            return config.publicUrl + rest + "/" + size + fileName + extension;
        }
        else {
            return src;
        }
    }
};
exports.NextStrapiImageLoader = NextStrapiImageLoader;
